<?php

namespace backend\controllers;

use Yii;
use common\models\Customer;
use backend\models\CustomerSearch;
use backend\models\CustomerCreate;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\base\Object;
use backend\models\CustomerUpdate;
use backend\models\CustomerNewsLetterModel;
use yii\db\Query;
use yii\data\ActiveDataProvider;

/**
 * CustomerController implements the CRUD actions for Customer model.
 */
class CustomerController extends \backend\controllers\BackendController
{

	

	public function behaviors()
	{
		return [
				'access' => [
						'class' => \yii\filters\AccessControl::className(),
						'rules' => [
								// allow authenticated users
								[
										'actions' => ['create','index','view','update','mail'],
										'allow' => true,
										'roles' => ['admin','employee','reception'],
								],
								// everything else is denied
						],
				],
		];
	}
	
	
    /**
     * Lists all Customer models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new CustomerSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Customer model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Customer model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new CustomerCreate();
        
        $model->country = "Magyarország";
        $model->id_user = Yii::$app->user->id;
        

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_customer]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Customer model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
   	   if (($model = CustomerUpdate::findOne($id))  == null) {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
        
        $model->birthdate= isset($model->birthdate ) ? Yii::$app->formatter->asDate($model->birthdate) :'';
        

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_customer]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Customer model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

     */
    /**
     * Finds the Customer model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Customer the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Customer::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
    
    
    public function actionMail(){
    	$model = new CustomerNewsLetterModel();
    	
    	$query = new Query();
    	$query->distinct();
    	$query->select([  'email']);
    	$query->from("customer");
    	$query->andWhere(['newsletter' => 1]);
    	$query->andWhere(['status' => Customer::STATUS_ACTIVE]);
    	
    	
    	if ($model->load(Yii::$app->request->post()) && $model->validate()) {
    	
    	
    	$message = \Yii::$app->mailer->compose (  );
    	
	    	$message
	    	->setFrom ( "noreply@fitnessadmin.hu" )
	    	->setBcc(['rocho02@gmail.com',"rocho02@freemail.hu"])
	    	//->setTo(['rocho02@gmail.com'])
	    	->setHtmlBody($model->text )
	    	->setSubject (  $model->subject )
	    	->send ();
	    	return $this->redirect(['customer/mail']);
    	}
   		 
    	
    	return $this->render('mail', [ 'model' => $model  	]);
    }
    
}
